<template>
  <div id="content-wrap">
    <div class="actions">
      <div id="buttons">
        <button id="new"
        v-on:click="$emit('change-component', 'Delivery'); $emit('string', 'a')">
          Create New
        </button>
      </div>
    </div>
    <div class="table-wrap">
      <table class="tab">
        <thead>
          <tr>
            <th>TrackingId</th>
            <th>Sent_date</th>
            <th>Status</th>
            <th>Type</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="delivery in deliveries" v-bind:key="delivery.id" v-bind:item="delivery">
            <td>{{delivery.trackingId}}</td>
            <td>{{delivery.sentDate}}</td>
            <td>{{delivery.status}}</td>
            <td>{{delivery.type}}</td>
            <td>
              <button v-on:click="modify(delivery.trackingId)">Modify</button>
              <button v-on:click="deleteObj(delivery)">Delete</button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Deliveries',
  data() {
    return {
      deliveries: [],
    };
  },
  mounted() {
    this.get();
  },
  methods: {
    get() {
      axios.get('http://localhost:4000/api/deliveries').then(
        (result) => {
          this.deliveries = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    modify(obj) {
      this.$emit('change-component', 'Delivery');
      this.$emit('string', obj);
      console.log(obj);
    },
    deleteObj(delivery) {
      const url = `http://localhost:4000/api/deliveries/${delivery.trackingiId}`;
      axios.delete(url).then(
        (result) => {
          if (result) { this.get(); }
        },
      ).catch((error) => {
        console.log(error);
      });
    },
  },
};
</script>

<style scoped>
@import "../CSS/Managment.css";
</style>
